-- shore

local shore_tower_items = {
	["stick of dynamite"] = "Distant Lands Dude Ranch Adventure",
	["tropical orchid"] = "Tropical Paradise Island Getaway",
	["barbed-wire fence"] = "Large Donkey Mountain Ski Resort",
}

add_printer("/shore.php", function()
	local tbl = ascension["zone.lair.itemsneeded"] or {}
	for from, to in pairs(tbl) do
		if (shore_tower_items[to]) then
			dest = shore_tower_items[to]
			text = text:gsub("(<td valign=center>)("..dest..")(</td>)", "%1<b>%2</b>%3")
		end
	end
end)

add_processor("/shore.php", function ()
	if text:contains([[<td style="color: white;" align=center bgcolor=blue><b>Vacation Results:</b>]]) then
		local trips_text = text:match("You have taken (.-) trip")
		local found_combat_item = false
		for x, _ in pairs(shore_tower_items) do
			if text:contains(x) then
				found_combat_item = true
			end
		end
		if trips_text == "one" or found_combat_item then
			ascension["shore turn"] = turnsthisrun() + 35
		end
	end
end)

add_printer("/charpane.php", function()
	local turnsthisrun = tonumber(text:match("var turnsthisrun = ([0-9]+);"))
	if not turnsthisrun then return end
	local shore_next_combat_item_turn = ascension["shore turn"]
	local value = nil
	if shore_next_combat_item_turn then
		local turns = shore_next_combat_item_turn - turnsthisrun
		if turns >= 0 then
			value = turns
		end
	else
-- 		value = "?"
	end
	if value then
		print_charpane_value({ name = "Shore", value = value })
	end
end)

add_automator("/beach.php", function()
	if params.action == "woodencity" then
		if text:contains("commence to getting that staff") then
			local pwd = get_session_state("pwd") -- careful!
			plunge_items("ancient amulet", "Eye of Ed", pwd)
			plunge_items("ancient amulet", "Staff of Fats", pwd)
			plunge_items("Staff of Fats", "headpiece of the Staff of Ed", pwd)
			plunge_items("Eye of Ed", "Staff of Ed, almost", pwd)
			text = post_page("/beach.php", params)
		end
	end
end)

add_automator("/shore.php", function ()
	if text:contains([[MacGuffin diary]]) then
		text, url = get_page("/diary.php", { whichpage = "1" }) -- Should it display the shore page or the diary page?
	end
end)
